/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the WhatsAppTemplateDefaultsCard type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &WhatsAppTemplateDefaultsCard{}

// WhatsAppTemplateDefaultsCard struct for WhatsAppTemplateDefaultsCard
type WhatsAppTemplateDefaultsCard struct {
	CardIndex *int64 `json:"card_index,omitempty"`
	Components []WhatsAppTemplateDefaultsComponent `json:"components,omitempty"`
}

// NewWhatsAppTemplateDefaultsCard instantiates a new WhatsAppTemplateDefaultsCard object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewWhatsAppTemplateDefaultsCard() *WhatsAppTemplateDefaultsCard {
	this := WhatsAppTemplateDefaultsCard{}
	return &this
}

// NewWhatsAppTemplateDefaultsCardWithDefaults instantiates a new WhatsAppTemplateDefaultsCard object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewWhatsAppTemplateDefaultsCardWithDefaults() *WhatsAppTemplateDefaultsCard {
	this := WhatsAppTemplateDefaultsCard{}
	return &this
}

// GetCardIndex returns the CardIndex field value if set, zero value otherwise.
func (o *WhatsAppTemplateDefaultsCard) GetCardIndex() int64 {
	if o == nil || IsNil(o.CardIndex) {
		var ret int64
		return ret
	}
	return *o.CardIndex
}

// GetCardIndexOk returns a tuple with the CardIndex field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateDefaultsCard) GetCardIndexOk() (*int64, bool) {
	if o == nil || IsNil(o.CardIndex) {
		return nil, false
	}
	return o.CardIndex, true
}

// HasCardIndex returns a boolean if a field has been set.
func (o *WhatsAppTemplateDefaultsCard) HasCardIndex() bool {
	if o != nil && !IsNil(o.CardIndex) {
		return true
	}

	return false
}

// SetCardIndex gets a reference to the given int64 and assigns it to the CardIndex field.
func (o *WhatsAppTemplateDefaultsCard) SetCardIndex(v int64) {
	o.CardIndex = &v
}

// GetComponents returns the Components field value if set, zero value otherwise.
func (o *WhatsAppTemplateDefaultsCard) GetComponents() []WhatsAppTemplateDefaultsComponent {
	if o == nil || IsNil(o.Components) {
		var ret []WhatsAppTemplateDefaultsComponent
		return ret
	}
	return o.Components
}

// GetComponentsOk returns a tuple with the Components field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateDefaultsCard) GetComponentsOk() ([]WhatsAppTemplateDefaultsComponent, bool) {
	if o == nil || IsNil(o.Components) {
		return nil, false
	}
	return o.Components, true
}

// HasComponents returns a boolean if a field has been set.
func (o *WhatsAppTemplateDefaultsCard) HasComponents() bool {
	if o != nil && !IsNil(o.Components) {
		return true
	}

	return false
}

// SetComponents gets a reference to the given []WhatsAppTemplateDefaultsComponent and assigns it to the Components field.
func (o *WhatsAppTemplateDefaultsCard) SetComponents(v []WhatsAppTemplateDefaultsComponent) {
	o.Components = v
}

func (o WhatsAppTemplateDefaultsCard) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o WhatsAppTemplateDefaultsCard) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.CardIndex) {
		toSerialize["card_index"] = o.CardIndex
	}
	if !IsNil(o.Components) {
		toSerialize["components"] = o.Components
	}
	return toSerialize, nil
}

type NullableWhatsAppTemplateDefaultsCard struct {
	value *WhatsAppTemplateDefaultsCard
	isSet bool
}

func (v NullableWhatsAppTemplateDefaultsCard) Get() *WhatsAppTemplateDefaultsCard {
	return v.value
}

func (v *NullableWhatsAppTemplateDefaultsCard) Set(val *WhatsAppTemplateDefaultsCard) {
	v.value = val
	v.isSet = true
}

func (v NullableWhatsAppTemplateDefaultsCard) IsSet() bool {
	return v.isSet
}

func (v *NullableWhatsAppTemplateDefaultsCard) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWhatsAppTemplateDefaultsCard(val *WhatsAppTemplateDefaultsCard) *NullableWhatsAppTemplateDefaultsCard {
	return &NullableWhatsAppTemplateDefaultsCard{value: val, isSet: true}
}

func (v NullableWhatsAppTemplateDefaultsCard) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWhatsAppTemplateDefaultsCard) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


